function ep_pos_models(instance,module)
{
	var QWeb = instance.web.qweb;
	var _t = instance.web._t;

    var round_di = instance.web.round_decimals;
    var round_pr = instance.web.round_precision;
    
    module.PosModel.prototype.models.push(
	{
        model:  'pos.currency.line',
        fields: ['pos_config_id','currency_id','rate_silent'],
        domain: function(self){return [['pos_config_id','=', self.pos_session.config_id[0]]]; },
        loaded: function(self, currency_list_lines)
        {
        	self.currency_list_lines=currency_list_lines;
        },
    },
	{
        model:  'res.currency',
        fields: ['name','rate_silent','rounding','symbol','position','accuracy'],
        domain:  function(self)
		{
			if (self.config.multi_currency_enable && self.config.fetch_master)
				return [[1,'=',1]];
			else if (self.config.multi_currency_enable && !self.config.fetch_master)
			{
				selected_ids=[]
				for (i in self.currency_list_lines)
				{
					selected_ids.push(self.currency_list_lines[i].currency_id[0]);
				}
				return [['id','in',selected_ids]];
			}
		},
        loaded: function(self, currency_list)
        {
        	if (self.config.multi_currency_enable && self.config.fetch_master)
    		{
        		self.currency_list = currency_list;
	            var length = 0;
	
			    for(var prop in self.currency_list) 
			    {
			        if(currency_list.hasOwnProperty(prop))
		        	{ 
			            ++length;
				        if (self.currency_list[prop].rounding > 0) 
			                self.currency_list[prop].decimals = Math.ceil(Math.log(1.0 /  self.currency_list[prop].rounding) / Math.log(10));
				        else 
				        	self.currency_list[prop].decimals = 0;
		        	}
			    }
	
			    self.currency_list.length=length;
    		}
        	else if(self.config.multi_currency_enable && self.config.fetch_master==false)
    		{
        		currency_ids=[];
        		for (i in self.currency_list_lines)
    			{
        			currency_ids.push(self.currency_list_lines[i].currency_id[0]);
    			}
        		self.currency_list=[];
        		for (i in currency_list)
        			for (j in self.currency_list_lines)
        				if (currency_list[i].id == self.currency_list_lines[j].currency_id[0])
	    				{
        					if (self.currency_list_lines[j].rate_silent>0)
        						currency_list[i].rate_silent=self.currency_list_lines[j].rate_silent;
	        				self.currency_list.push(currency_list[i]);
	    				}

        		var length = 0;
			    for(var prop in self.currency_list) 
			    {
			        if(currency_list.hasOwnProperty(prop))
		        	{ 
			            ++length;
				        if (self.currency_list[prop].rounding > 0) 
			                self.currency_list[prop].decimals = Math.ceil(Math.log(1.0 /  self.currency_list[prop].rounding) / Math.log(10));
				        else 
				        	self.currency_list[prop].decimals = 0;
		        	}
			    }
	
			    self.currency_list.length=length;
    		}
        	
        },
    });
    
    module.Order = module.Order.extend({
		initialize: function(attributes)
		{
            Backbone.Model.prototype.initialize.apply(this, arguments);
            this.pos = attributes.pos; 
            this.sequence_number = this.pos.pos_session.sequence_number++;
            this.uid =     this.generateUniqueId();
            this.set(
        		{
                creationDate:   new Date(),
                orderLines:     new module.OrderlineCollection(),
                paymentLines:   new module.PaymentlineCollection(),
                name:           _t("Order ") + this.uid,
                client:         null,
        		});
            this.selected_orderline   = undefined;
            this.selected_paymentline = undefined;
            this.screen_data = {};  // see ScreenSelector
            this.receipt_type = 'receipt';  // 'receipt' || 'invoice'
            this.temporary = attributes.temporary || false;

            if (this.pos.config.multi_currency_enable)
        	{
	            if (this.pos.currency_list.length>0)
	            	this.foreign_currency=$.extend({}, this.pos.currency_list[0]);
	            else
	            	this.foreign_currency=false;
	            this.multi_currency_checked=false;
	            this.currency_total=0;
	            this.currency_change=0;
	            this.currency_paid=0;
	            this.curr_input_selected=false;
        	}
            return this;
        },
	});
}